class HdaAppServertweetInstaller
	def up
		appname = "server_tweet"
		app = "hda_app_" + appname
		tgt = "#{HDA_BASE}/platform/html"
		FileUtils.cd("#{HDA_BASE}/platform/apps/servertweet") do
			FileUtils.cp("app/controllers/hda_app_#{appname}_controller.rb", "#{tgt}/app/controllers")
			# FileUtils.cp("app/helpers/hda_app_#{appname}_helper.rb", "#{tgt}/app/helpers")
			FileUtils.cp("app/models/hda_app_#{appname}.rb", "#{tgt}/app/models")
			FileUtils.mkdir_p("#{tgt}/app/views/#{app}")
			FileUtils.cp_r(Dir.glob("app/views/#{app}/*"), "#{tgt}/app/views/#{app}")
			# FileUtils.mkdir_p("#{tgt}/public/images/#{app}")
			# FileUtils.cp_r("public/images/.", "#{tgt}/public/images/#{app}/")
		end
		ServerTweetTable.migrate :up
		load "#{tgt}/app/models/hda_app_#{appname}.rb"
		load "#{tgt}/app/controllers/hda_app_#{appname}_controller.rb"
		# load "#{tgt}/app/helpers/hda_app_#{appname}_helper.rb"
		true
	end

	def down
		appname = "servertweet"
		app = "hda_app_" + appname
		tgt = "#{HDA_BASE}/platform/html"
		FileUtils.cd(tgt) do
			FileUtils.rm("app/controllers/hda_app_#{appname}_controller.rb", :force => true)
			# FileUtils.rm("app/helpers/hda_app_#{appname}_helper.rb", :force => true)
			FileUtils.rm("app/models/hda_app_#{appname}.rb", :force => true)
			FileUtils.rm_r("app/views/hda_app_#{appname}", :force => true)
			FileUtils.rm_rf("public/images/#{app}")
		end
		ServerTweetTable.migrate :down
		true
	end

	def user_up u
	  true
	end
end

class ServerTweetTable < ActiveRecord::Migration
  def self.up
	begin
	    create_table :hda_app_server_tweets do |t|
			t.column :name, :string
			t.column :enabled, :bool, :default => true
			t.column :settings, :string
			t.datetime :last_sent
	    end
	rescue
	end

	HdaAppServerTweet.reset_column_information

	# FIXME pre-populate database here if needed
  end

  def self.down
	drop_table :hda_app_server_tweets
  end
end

